#!/bin/bash
#######################################################
# 解像度変更(aileun4用)
#######################################################

ROTATE_CONFIG="/opt/aile/config/DisplayRotate.conf"
VIEWER_CONFIG="/opt/aile/config/ViewerConfig.conf"
HwCheckCmd="/opt/aile/hwcheck"
solt=`date +"%Y%m%d%H%M%S"`
PRODUCT_FILE="/tmp/prdx2wr"
ROTATE="normal"

hwhash=`$HwCheckCmd $solt`
PRODUCT=`cat $PRODUCT_FILE | grep YS15 | wc -l`
if [ $PRODUCT = 1 ]; then
	exit;
fi

MODEL_4CH=`cat $PRODUCT_FILE | grep YS-2104 | wc -l`
if [ -e $VIEWER_CONFIG ]; then
	VIEWER_SPLIT=`cat $VIEWER_CONFIG | grep "Split" | awk -F':' '{print $2}'`
	if [ -e $ROTATE_CONFIG ]; then
		if [ $VIEWER_SPLIT = 8 -o $VIEWER_SPLIT = 9 ]; then
			ROTATE="normal"
			DISPLAY_DIRECTION=`cat $ROTATE_CONFIG | awk -F'_' '{print $1}'`
			if [ "$DISPLAY_DIRECTION" = "vertical" ]; then
				ROTATE=`cat $ROTATE_CONFIG | awk -F'_' '{print $2}'`
			fi
		fi
	fi
	# 4ch版で2分割（縦）以外の回転は無効にする
	if [ $MODEL_4CH = 1 ]; then
		if [ $VIEWER_SPLIT != 8 -a "$ROTATE" != "normal" ]; then
			ROTATE="normal"
		fi
	fi
fi

case $ROTATE in
	"left") ;;
	"right") ;;
	"inverted") ;;
	* ) ROTATE="normal" ;; 
esac

#xrandr -q | logger -t StartAile
OUTPUT_MONITOR=("HDMI1" "DP1")
REQUIRE_RESOLUTION=1024
SCALE_MAX_RESOLUTION=3000
TARGET_RESOLUTION="1080"
MAX_RESOLUTION_SIZE=0
MIN_RESOLUTION_SIZE=$REQUIRE_RESOLUTION
RESOLUTION_X=0
RESOLUTION_Y=0
RESOLUTION_SIZE=0
XRANDR_STR=("" "")
APP_WARNING_FILE=/tmp/app_warn_resolution
R_RESOLUTION_X=("" "")
R_RESOLUTION_Y=("" "")

if [ $ROTATE = "left" ] || [ $ROTATE = "right" ]; then
	if [ $(xrandr -q | grep "DP1" | awk '{print $2}') = "connected" ]; then
		xrandr --output HDMI1 --off --output DP1 --auto --rotate $ROTATE
	else
		xrandr --output DP1 --off --output HDMI1 --auto --rotate $ROTATE
	fi
else
	xrandr --output HDMI1 --auto --rotate $ROTATE --output DP1 --auto --rotate $ROTATE
fi

for ((i=0; i<${#OUTPUT_MONITOR[@]}; i++)); do
	XRANDR_STR[$i]=`xrandr -q | grep ${OUTPUT_MONITOR[$i]}`
	if [ $(echo ${XRANDR_STR[$i]} | awk '{print $2}') = "connected" ]; then
		if [ $(echo ${XRANDR_STR[$i]} | awk '{print $3}') = "primary" ]; then
			RESOLUTION_X=$(echo ${XRANDR_STR[$i]} | awk -F'[ +x]+' '{print $4}')
			RESOLUTION_Y=$(echo ${XRANDR_STR[$i]} | awk -F'[ +x]+' '{print $5}')
			R_RESOLUTION_X[$i]=$RESOLUTION_X
			R_RESOLUTION_Y[$i]=$RESOLUTION_Y
		else
			RESOLUTION_X=$(echo ${XRANDR_STR[$i]} | awk -F'[ +x]+' '{print $3}')
			RESOLUTION_Y=$(echo ${XRANDR_STR[$i]} | awk -F'[ +x]+' '{print $4}')
			R_RESOLUTION_X[$i]=$RESOLUTION_X
			R_RESOLUTION_Y[$i]=$RESOLUTION_Y
		fi

		if [[ $RESOLUTION_X =~ ^[0123456789]+$ ]]; then
			RESOLUTION_SIZE=`expr ${RESOLUTION_X} + ${RESOLUTION_Y}`
			if [ "${RESOLUTION_SIZE}" -gt "${MAX_RESOLUTION_SIZE}" ]; then
				MAX_RESOLUTION_SIZE[$i]=${RESOLUTION_SIZE}
				if [ "${RESOLUTION_X}" -gt "${RESOLUTION_Y}" ]; then
					if [ "${RESOLUTION_Y}" -gt "${TARGET_RESOLUTION}" ]; then
						TARGET_RESOLUTION=${RESOLUTION_Y}
					fi
					TARGET_RESOLUTION_Y=${TARGET_RESOLUTION}
					TARGET_RESOLUTION_X=`echo "scale=0; ${TARGET_RESOLUTION}*${RESOLUTION_X}/${RESOLUTION_Y}" | bc`
				else
					if [ "${RESOLUTION_X}" -gt "${TARGET_RESOLUTION}" ]; then
						TARGET_RESOLUTION=${RESOLUTION_X}
					fi
					TARGET_RESOLUTION_X=${TARGET_RESOLUTION}
					TARGET_RESOLUTION_Y=`echo "scale=0; ${TARGET_RESOLUTION}*${RESOLUTION_Y}/${RESOLUTION_X}" | bc`
				fi
			fi
			if [ "${MIN_RESOLUTION_SIZE}" -gt "${RESOLUTION_Y}" ]; then
				MIN_RESOLUTION_SIZE=$RESOLUTION_Y
			fi
			if [ "${MIN_RESOLUTION_SIZE}" -gt "${RESOLUTION_X}" ]; then
				MIN_RESOLUTION_SIZE=$RESOLUTION_X
			fi
		fi
	fi
done

if [ $(echo ${XRANDR_STR[1]} | awk '{print $2}') = "connected" ]; then
	HDMI_STATUS=`echo ${XRANDR_STR[0]} | awk '{print $2}'`
	if [ $ROTATE = "left" ] || [ $ROTATE = "right" ]; then
		if [ $MIN_RESOLUTION_SIZE -ge $REQUIRE_RESOLUTION ]; then
			xrandr --output HDMI1 --off --output DP1 --auto --rotate $ROTATE
			logger -t StartAile "modify DP1 xrandr connect:connected real:"${R_RESOLUTION_X[1]}"x"${R_RESOLUTION_Y[1]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}
			logger -t StartAile "modify HDMI1 xrandr connect:"$HDMI_STATUS"(off) real:"${R_RESOLUTION_X[0]}"x"${R_RESOLUTION_Y[0]}
		else
			xrandr --output HDMI1 --auto --rotate normal --output DP1 --auto --rotate normal
			xrandr --output DP1 --scale-from ${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}
			xrandr --output HDMI1 --scale-from ${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}
			touch $APP_WARNING_FILE
			logger -t StartAile "modify DP1 xrandr connect:connected real:"${R_RESOLUTION_X[1]}"x"${R_RESOLUTION_Y[1]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}"(normal)"
			logger -t StartAile "modify HDMI1 xrandr connect:connected real:"${R_RESOLUTION_X[0]}"x"${R_RESOLUTION_Y[0]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}"(normal)"
		fi
	else
		if [ "$SCALE_MAX_RESOLUTION" -ge "$MAX_RESOLUTION_SIZE" ]; then
			xrandr --output DP1 --scale-from ${TARGET_RESOLUTION_X}"x"${TARGET_RESOLUTION_Y}
			xrandr --output HDMI1 --scale-from ${TARGET_RESOLUTION_X}"x"${TARGET_RESOLUTION_Y}
			logger -t StartAile "modify DP1 xrandr connect:connected real:"${R_RESOLUTION_X[1]}"x"${R_RESOLUTION_Y[1]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}
			logger -t StartAile "modify HDMI1 xrandr connect:connected real:"${R_RESOLUTION_X[0]}"x"${R_RESOLUTION_Y[0]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}
		fi
	fi
else
	if [ $ROTATE = "left" ] || [ $ROTATE = "right" ]; then
		if [ $MIN_RESOLUTION_SIZE -ge $REQUIRE_RESOLUTION ]; then
			xrandr --output DP1 --off --output HDMI1 --auto --rotate $ROTATE
			logger -t StartAile "modify DP1 xrandr connect:disconnected"
			logger -t StartAile "modify HDMI1 xrandr connect:connected real:"${R_RESOLUTION_X[0]}"x"${R_RESOLUTION_Y[0]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}
		else
			xrandr --output DP1 --off --output HDMI1 --auto --rotate normal
			xrandr --output HDMI1 --scale-from ${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}
			touch $APP_WARNING_FILE
			logger -t StartAile "modify DP1 xrandr connect:disconnected"
			logger -t StartAile "modify HDMI1 xrandr connect:connected real:"${R_RESOLUTION_X[0]}"x"${R_RESOLUTION_Y[0]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}"(normal)"
		fi
	else
		if [ "$SCALE_MAX_RESOLUTION" -ge "$MAX_RESOLUTION_SIZE" ]; then
			xrandr --output HDMI1 --scale-from ${TARGET_RESOLUTION_X}"x"${TARGET_RESOLUTION_Y}
			logger -t StartAile "modify DP1 xrandr connect:disconnected"
			logger -t StartAile "modify HDMI1 xrandr connect:connected real:"${R_RESOLUTION_X[0]}"x"${R_RESOLUTION_Y[0]}" scale:"${TARGET_RESOLUTION_Y}"x"${TARGET_RESOLUTION_X}" rotate:"${ROTATE}
		fi
	fi
fi

### EOF ###
